
void _efl_ui_collection_item_scroll(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Ui_Item *item, Eina_Bool animation);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_collection_item_scroll, EFL_FUNC_CALL(item, animation), Efl_Ui_Item *item, Eina_Bool animation);

void _efl_ui_collection_item_scroll_align(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Ui_Item *item, double align, Eina_Bool animation);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_collection_item_scroll_align, EFL_FUNC_CALL(item, align, animation), Efl_Ui_Item *item, double align, Eina_Bool animation);

void _efl_ui_collection_position_manager_set(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Ui_Position_Manager_Entity *position_manager);

static void
_efl_ui_collection_position_manager_set_ownership_fallback(Efl_Ui_Position_Manager_Entity *position_manager)
{
   efl_del(position_manager);
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_FALLBACK(efl_ui_collection_position_manager_set, _efl_ui_collection_position_manager_set_ownership_fallback(position_manager);, EFL_FUNC_CALL(position_manager), Efl_Ui_Position_Manager_Entity *position_manager);

Efl_Ui_Position_Manager_Entity *_efl_ui_collection_position_manager_get(const Eo *obj, Efl_Ui_Collection_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_collection_position_manager_get, Efl_Ui_Position_Manager_Entity *, NULL);

Efl_Object *_efl_ui_collection_efl_object_constructor(Eo *obj, Efl_Ui_Collection_Data *pd);


Efl_Object *_efl_ui_collection_efl_object_finalize(Eo *obj, Efl_Ui_Collection_Data *pd);


void _efl_ui_collection_efl_object_destructor(Eo *obj, Efl_Ui_Collection_Data *pd);


void _efl_ui_collection_efl_object_invalidate(Eo *obj, Efl_Ui_Collection_Data *pd);


Eina_Iterator *_efl_ui_collection_efl_container_content_iterate(Eo *obj, Efl_Ui_Collection_Data *pd);


int _efl_ui_collection_efl_container_content_count(Eo *obj, Efl_Ui_Collection_Data *pd);


void _efl_ui_collection_efl_ui_layout_orientable_orientation_set(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Ui_Layout_Orientation dir);


Efl_Ui_Layout_Orientation _efl_ui_collection_efl_ui_layout_orientable_orientation_get(const Eo *obj, Efl_Ui_Collection_Data *pd);


Eina_Error _efl_ui_collection_efl_ui_widget_theme_apply(Eo *obj, Efl_Ui_Collection_Data *pd);


Eina_Bool _efl_ui_collection_efl_pack_pack_clear(Eo *obj, Efl_Ui_Collection_Data *pd);


Eina_Bool _efl_ui_collection_efl_pack_unpack_all(Eo *obj, Efl_Ui_Collection_Data *pd);


Eina_Bool _efl_ui_collection_efl_pack_unpack(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Gfx_Entity *subobj);


Eina_Bool _efl_ui_collection_efl_pack_pack(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Gfx_Entity *subobj);


Eina_Bool _efl_ui_collection_efl_pack_linear_pack_end(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Gfx_Entity *subobj);


Eina_Bool _efl_ui_collection_efl_pack_linear_pack_begin(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Gfx_Entity *subobj);


Eina_Bool _efl_ui_collection_efl_pack_linear_pack_before(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Gfx_Entity *subobj, const Efl_Gfx_Entity *existing);


Eina_Bool _efl_ui_collection_efl_pack_linear_pack_after(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Gfx_Entity *subobj, const Efl_Gfx_Entity *existing);


Eina_Bool _efl_ui_collection_efl_pack_linear_pack_at(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Gfx_Entity *subobj, int index);


Efl_Gfx_Entity *_efl_ui_collection_efl_pack_linear_pack_unpack_at(Eo *obj, Efl_Ui_Collection_Data *pd, int index);


int _efl_ui_collection_efl_pack_linear_pack_index_get(Eo *obj, Efl_Ui_Collection_Data *pd, const Efl_Gfx_Entity *subobj);


Efl_Gfx_Entity *_efl_ui_collection_efl_pack_linear_pack_content_get(Eo *obj, Efl_Ui_Collection_Data *pd, int index);


void _efl_ui_collection_efl_ui_scrollable_match_content_set(Eo *obj, Efl_Ui_Collection_Data *pd, Eina_Bool w, Eina_Bool h);


Efl_Ui_Focus_Manager *_efl_ui_collection_efl_ui_widget_focus_manager_focus_manager_create(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Ui_Focus_Object *root);


Eina_Bool _efl_ui_collection_efl_ui_widget_focus_state_apply(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Ui_Widget_Focus_State current_state, Efl_Ui_Widget_Focus_State *configured_state, Efl_Ui_Widget *redirect);


Efl_Ui_Focus_Object *_efl_ui_collection_efl_ui_focus_manager_move(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Ui_Focus_Direction direction);


Efl_Ui_Selectable *_efl_ui_collection_efl_ui_single_selectable_last_selected_get(const Eo *obj, Efl_Ui_Collection_Data *pd);


void _efl_ui_collection_efl_ui_multi_selectable_select_mode_set(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Ui_Select_Mode mode);


Efl_Ui_Select_Mode _efl_ui_collection_efl_ui_multi_selectable_select_mode_get(const Eo *obj, Efl_Ui_Collection_Data *pd);


void _efl_ui_collection_efl_ui_multi_selectable_all_select(Eo *obj, Efl_Ui_Collection_Data *pd);


void _efl_ui_collection_efl_ui_multi_selectable_all_unselect(Eo *obj, Efl_Ui_Collection_Data *pd);


Eina_Iterator *_efl_ui_collection_efl_ui_multi_selectable_object_range_selected_iterator_new(Eo *obj, Efl_Ui_Collection_Data *pd);


void _efl_ui_collection_efl_ui_multi_selectable_object_range_range_select(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Ui_Selectable *a, Efl_Ui_Selectable *b);


void _efl_ui_collection_efl_ui_multi_selectable_object_range_range_unselect(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Ui_Selectable *a, Efl_Ui_Selectable *b);


void _efl_ui_collection_efl_ui_single_selectable_fallback_selection_set(Eo *obj, Efl_Ui_Collection_Data *pd, Efl_Ui_Selectable *fallback);


Efl_Ui_Selectable *_efl_ui_collection_efl_ui_single_selectable_fallback_selection_get(const Eo *obj, Efl_Ui_Collection_Data *pd);


void _efl_ui_collection_efl_ui_single_selectable_allow_manual_deselection_set(Eo *obj, Efl_Ui_Collection_Data *pd, Eina_Bool allow_manual_deselection);


Eina_Bool _efl_ui_collection_efl_ui_single_selectable_allow_manual_deselection_get(const Eo *obj, Efl_Ui_Collection_Data *pd);


static Eina_Bool
_efl_ui_collection_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_COLLECTION_EXTRA_OPS
#define EFL_UI_COLLECTION_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_collection_item_scroll, _efl_ui_collection_item_scroll),
      EFL_OBJECT_OP_FUNC(efl_ui_collection_item_scroll_align, _efl_ui_collection_item_scroll_align),
      EFL_OBJECT_OP_FUNC(efl_ui_collection_position_manager_set, _efl_ui_collection_position_manager_set),
      EFL_OBJECT_OP_FUNC(efl_ui_collection_position_manager_get, _efl_ui_collection_position_manager_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_collection_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_finalize, _efl_ui_collection_efl_object_finalize),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_ui_collection_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_invalidate, _efl_ui_collection_efl_object_invalidate),
      EFL_OBJECT_OP_FUNC(efl_content_iterate, _efl_ui_collection_efl_container_content_iterate),
      EFL_OBJECT_OP_FUNC(efl_content_count, _efl_ui_collection_efl_container_content_count),
      EFL_OBJECT_OP_FUNC(efl_ui_layout_orientation_set, _efl_ui_collection_efl_ui_layout_orientable_orientation_set),
      EFL_OBJECT_OP_FUNC(efl_ui_layout_orientation_get, _efl_ui_collection_efl_ui_layout_orientable_orientation_get),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_theme_apply, _efl_ui_collection_efl_ui_widget_theme_apply),
      EFL_OBJECT_OP_FUNC(efl_pack_clear, _efl_ui_collection_efl_pack_pack_clear),
      EFL_OBJECT_OP_FUNC(efl_pack_unpack_all, _efl_ui_collection_efl_pack_unpack_all),
      EFL_OBJECT_OP_FUNC(efl_pack_unpack, _efl_ui_collection_efl_pack_unpack),
      EFL_OBJECT_OP_FUNC(efl_pack, _efl_ui_collection_efl_pack_pack),
      EFL_OBJECT_OP_FUNC(efl_pack_end, _efl_ui_collection_efl_pack_linear_pack_end),
      EFL_OBJECT_OP_FUNC(efl_pack_begin, _efl_ui_collection_efl_pack_linear_pack_begin),
      EFL_OBJECT_OP_FUNC(efl_pack_before, _efl_ui_collection_efl_pack_linear_pack_before),
      EFL_OBJECT_OP_FUNC(efl_pack_after, _efl_ui_collection_efl_pack_linear_pack_after),
      EFL_OBJECT_OP_FUNC(efl_pack_at, _efl_ui_collection_efl_pack_linear_pack_at),
      EFL_OBJECT_OP_FUNC(efl_pack_unpack_at, _efl_ui_collection_efl_pack_linear_pack_unpack_at),
      EFL_OBJECT_OP_FUNC(efl_pack_index_get, _efl_ui_collection_efl_pack_linear_pack_index_get),
      EFL_OBJECT_OP_FUNC(efl_pack_content_get, _efl_ui_collection_efl_pack_linear_pack_content_get),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_match_content_set, _efl_ui_collection_efl_ui_scrollable_match_content_set),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_focus_manager_create, _efl_ui_collection_efl_ui_widget_focus_manager_focus_manager_create),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_focus_state_apply, _efl_ui_collection_efl_ui_widget_focus_state_apply),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_move, _efl_ui_collection_efl_ui_focus_manager_move),
      EFL_OBJECT_OP_FUNC(efl_ui_selectable_last_selected_get, _efl_ui_collection_efl_ui_single_selectable_last_selected_get),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_select_mode_set, _efl_ui_collection_efl_ui_multi_selectable_select_mode_set),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_select_mode_get, _efl_ui_collection_efl_ui_multi_selectable_select_mode_get),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_all_select, _efl_ui_collection_efl_ui_multi_selectable_all_select),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_all_unselect, _efl_ui_collection_efl_ui_multi_selectable_all_unselect),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_selected_iterator_new, _efl_ui_collection_efl_ui_multi_selectable_object_range_selected_iterator_new),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_range_select, _efl_ui_collection_efl_ui_multi_selectable_object_range_range_select),
      EFL_OBJECT_OP_FUNC(efl_ui_multi_selectable_range_unselect, _efl_ui_collection_efl_ui_multi_selectable_object_range_range_unselect),
      EFL_OBJECT_OP_FUNC(efl_ui_selectable_fallback_selection_set, _efl_ui_collection_efl_ui_single_selectable_fallback_selection_set),
      EFL_OBJECT_OP_FUNC(efl_ui_selectable_fallback_selection_get, _efl_ui_collection_efl_ui_single_selectable_fallback_selection_get),
      EFL_OBJECT_OP_FUNC(efl_ui_selectable_allow_manual_deselection_set, _efl_ui_collection_efl_ui_single_selectable_allow_manual_deselection_set),
      EFL_OBJECT_OP_FUNC(efl_ui_selectable_allow_manual_deselection_get, _efl_ui_collection_efl_ui_single_selectable_allow_manual_deselection_get),
      EFL_UI_COLLECTION_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_collection_class_desc = {
   EO_VERSION,
   "Efl.Ui.Collection",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Collection_Data),
   _efl_ui_collection_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_collection_class_get, &_efl_ui_collection_class_desc, EFL_UI_LAYOUT_BASE_CLASS, EFL_PACK_LINEAR_INTERFACE, EFL_UI_LAYOUT_ORIENTABLE_INTERFACE, EFL_UI_MULTI_SELECTABLE_OBJECT_RANGE_INTERFACE, EFL_UI_FOCUS_MANAGER_SUB_MIXIN, EFL_UI_WIDGET_FOCUS_MANAGER_MIXIN, EFL_UI_ITEM_CLICKABLE_INTERFACE, EFL_UI_SCROLLABLE_INTERFACE, EFL_UI_SCROLLBAR_INTERFACE, NULL);
